package com.zcxk.service.impl;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.zcxk.dao.AreaMapper;
import com.zcxk.dto.AreaDto;
import com.zcxk.entity.Area;
import com.zcxk.service.AreaService;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

import static com.google.common.collect.Lists.newArrayList;

/**
 * (Area表)服务实现类
 *
 * @author makejava
 * @since 2020-10-28 16:51:30
 */
@Service("areaService")
public class AreaServiceImpl implements AreaService {
    @Autowired
    private AreaMapper areaMapper;

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    @Override
    public Area selectById(Integer id) {
        return this.areaMapper.selectById(id);
    }


    /**
     * 查询所有
     *
     * @return 实例对象的集合
     */
    @Override
    public List<Area> selectAll() {
        return this.areaMapper.selectAll();
    }

    /**
     * 根据条件查询
     *
     * @return 实例对象的集合
     */
    @Override
    public List<AreaDto> selectList(Area area) {
        return getArea(this.areaMapper.selectList(area),100000,1);
    }
    public static List<AreaDto> getArea(List<AreaDto> list, Integer id, Integer leve) {
        List<AreaDto> temList = newArrayList();
        if (list != null) {
            for (AreaDto areaDto : list) {
                if (id.equals(areaDto.getPid())) {
                    List<AreaDto> chidren = getArea(list, areaDto.getCode(), ++leve);
                    AreaDto tempArea = new AreaDto();
                    BeanUtils.copyProperties(areaDto, tempArea);
                    tempArea.setChildren(chidren);
                    temList.add(tempArea);
                    leve--;
                }
            }
        }
        if(temList.size() > 0){
            return temList;
        }else {
            return null;
        }
    }

    /**
     * 新增数据
     *
     * @param area 实例对象
     * @return 实例对象
     */
    @Override
    public int insert(Area area) {
        return this.areaMapper.insert(area);
    }

    /**
     * 批量新增
     *
     * @param areas 实例对象的集合
     * @return 生效的条数
     */
    @Override
    public int batchInsert(List<Area> areas) {
        return this.areaMapper.batchInsert(areas);
    }

    /**
     * 修改数据
     *
     * @param area 实例对象
     * @return 实例对象
     */
    @Override
    public int update(Area area) {

        return this.areaMapper.update(area);
    }

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 是否成功
     */
    @Override
    public int deleteById(Integer id) {
        return this.areaMapper.deleteById(id);
    }

    /**
     * 查询总数据数
     *
     * @return 数据总数
     */
    @Override
    public int count() {
        return this.areaMapper.count();
    }

    /**
     * 分页查询
     *
     * @return 对象列表
     */
    @Override
    public IPage<Area> selectPage(Area area, IPage<Area> page) {
        return this.areaMapper.selectPage(page, area);
    }
}